org.apache.hc.core5.http.io.entity

## Class BasicHttpEntity

- java.lang.Object
- - org.apache.hc.core5.http.io.entity.AbstractHttpEntity
  - - org.apache.hc.core5.http.io.entity.BasicHttpEntity

- All Implemented Interfaces:
    Closeable, AutoCloseable, EntityDetails, HttpEntity

      @Contract(threading=IMMUTABLE_CONDITIONAL)
      public class BasicHttpEntity
      extends AbstractHttpEntity

  A generic streamed, non-repeatable entity that obtains its content from an `InputStream`.
  Since:
    4.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicHttpEntity(InputStream content, ContentType contentType)`
    `BasicHttpEntity(InputStream content, ContentType contentType, boolean chunked)`
    `BasicHttpEntity(InputStream content, ContentType contentType, String contentEncoding)`
    `BasicHttpEntity(InputStream content, long length, ContentType contentType)`
    `BasicHttpEntity(InputStream content, long length, ContentType contentType, String contentEncoding)`
    `BasicHttpEntity(InputStream content, long length, ContentType contentType, String contentEncoding, boolean chunked)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()`
    `InputStream` | `getContent()` Returns a content stream of the entity.
    `long` | `getContentLength()` Returns length of the entity, if known.
    `boolean` | `isRepeatable()` Tells if the entity is capable of producing its data more than once.
    `boolean` | `isStreaming()` Tells whether this entity depends on an underlying stream.

    - ### Methods inherited from class org.apache.hc.core5.http.io.entity.AbstractHttpEntity

      `getContentEncoding, getContentType, getTrailerNames, getTrailers, isChunked, toString, writeTo, writeTo`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### BasicHttpEntity

          public BasicHttpEntity(InputStream content,
                                 long length,
                                 ContentType contentType,
                                 String contentEncoding,
                                 boolean chunked)

    - #### BasicHttpEntity

          public BasicHttpEntity(InputStream content,
                                 long length,
                                 ContentType contentType,
                                 String contentEncoding)

    - #### BasicHttpEntity

          public BasicHttpEntity(InputStream content,
                                 long length,
                                 ContentType contentType)

    - #### BasicHttpEntity

          public BasicHttpEntity(InputStream content,
                                 ContentType contentType,
                                 String contentEncoding)

    - #### BasicHttpEntity

          public BasicHttpEntity(InputStream content,
                                 ContentType contentType)

    - #### BasicHttpEntity

          public BasicHttpEntity(InputStream content,
                                 ContentType contentType,
                                 boolean chunked)

  - ### Method Detail

    - #### getContentLength

          public final long getContentLength()

      Description copied from interface: `EntityDetails`
      Returns length of the entity, if known.

    - #### getContent

          public final InputStream getContent()
                                       throws IllegalStateException

      Description copied from interface: `HttpEntity`
      Returns a content stream of the entity. `Repeatable` entities are expected to create a new instance of `InputStream` for each invocation of this method and therefore can be consumed multiple times. Entities that are not `repeatable` are expected to return the same `InputStream` instance and therefore may not be consumed more than once.

      If this entity belongs to an incoming HTTP message, calling `InputStream.close()` on the returned `InputStream` will try to consume the complete entity content to keep the connection alive. In cases where this is undesired, e.g. when only a small part of the content is relevant and consuming the complete entity content would be too inefficient, only the HTTP message from which this entity was obtained should be closed (if supported).

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated after the `InputStream.close()` method is invoked.

      Returns:
        content stream of the entity.
      Throws:
        `IllegalStateException`
      See Also:
        `HttpEntity.isRepeatable()`

    - #### isRepeatable

          public final boolean isRepeatable()

      Description copied from interface: `HttpEntity`
      Tells if the entity is capable of producing its data more than once. A repeatable entity's getContent() and writeTo(OutputStream) methods can be called more than once whereas a non-repeatable entity's can not.
      Specified by:
        `isRepeatable` in interface `HttpEntity`
      Overrides:
        `isRepeatable` in class `AbstractHttpEntity`
      Returns:
        true if the entity is repeatable, false otherwise.

    - #### isStreaming

          public final boolean isStreaming()

      Description copied from interface: `HttpEntity`
      Tells whether this entity depends on an underlying stream. Streamed entities that read data directly from the socket should return `true`. Self-contained entities should return `false`. Wrapping entities should delegate this call to the wrapped entity.
      Returns:
        `true` if the entity content is streamed, `false` otherwise

    - #### close

          public final void close()
                           throws IOException

      Throws:
        `IOException`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.